												// Module Interface

typedef OSErr (*ModOpenProcPtr)(void *mpPtr);
typedef OSErr (*ModDrawProcPtr)(void *mpPtr);
typedef OSErr (*ModCloseProcPtr)(void *mpPtr);
typedef OSErr (*ModAboutProcPtr)(void *mpPtr);
typedef OSErr (*ModChangePrefsProcPtr)(void *mpPtr);

												// UPP DEFINITIONS
enum { 
	uppModOpenProcInfo = kCStackBased 
							| RESULT_SIZE(SIZE_CODE(sizeof(OSErr)))
							| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(void *))),

	uppModDrawProcInfo = kCStackBased 
							| RESULT_SIZE(SIZE_CODE(sizeof(OSErr)))
							| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(void *))),

	uppModCloseProcInfo = kCStackBased 
							| RESULT_SIZE(SIZE_CODE(sizeof(OSErr)))
							| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(void *))),

	uppModAboutProcInfo = kCStackBased 
							| RESULT_SIZE(SIZE_CODE(sizeof(OSErr)))
							| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(void *))),

	uppModChangePrefsProcInfo = kCStackBased 
							| RESULT_SIZE(SIZE_CODE(sizeof(OSErr)))
							| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(void *)))
};

												// PROC DESCRIPTOR - OPEN
#if USESROUTINEDESCRIPTORS
	typedef UniversalProcPtr ModOpenUPP;

	#define CallModOpenProc(userRoutine, modPBPtr)		\
			CallUniversalProc((UniversalProcPtr)userRoutine, uppModOpenProcInfo, modPBPtr)
			
	#define NewModOpenProc(userRoutine)		\
			(ModOpenUPP) NewRoutineDescriptor((ProcPtr)userRoutine, uppModOpenProcInfo, GetCurrentISA())
#else	
	typedef ModOpenProcPtr ModOpenUPP;
	
	#define CallModOpenProc(userRoutine, modPBPtr)		\
			(*userRoutine)(modPBPtr)

	#define NewModOpenProc(userRoutine)		\
			(ModOpenUPP)(userRoutine)
#endif


												// PROC DESCRIPTOR - DRAW
#if USESROUTINEDESCRIPTORS
	typedef UniversalProcPtr ModDrawUPP;

	#define CallModDrawProc(userRoutine, modPBPtr)		\
			CallUniversalProc((UniversalProcPtr)userRoutine, uppModDrawProcInfo, modPBPtr)
			
	#define NewModDrawProc(userRoutine)		\
			(ModOpenUPP) NewRoutineDescriptor((ProcPtr)userRoutine, uppModDrawProcInfo, GetCurrentISA())
#else	
	typedef ModDrawProcPtr ModDrawUPP;
	
	#define CallModDrawProc(userRoutine, modPBPtr)		\
			(*userRoutine)(modPBPtr)

	#define NewModDrawProc(userRoutine)		\
			(ModOpenUPP)(userRoutine)
#endif


												// PROC DESCRIPTOR - CLOSE
#if USESROUTINEDESCRIPTORS
	typedef UniversalProcPtr ModCloseUPP;

	#define CallModCloseProc(userRoutine, modPBPtr)		\
			CallUniversalProc((UniversalProcPtr)userRoutine, uppModCloseProcInfo, modPBPtr)
			
	#define NewModCloseProc(userRoutine)		\
			(ModOpenUPP) NewRoutineDescriptor((ProcPtr)userRoutine, uppModCloseProcInfo, GetCurrentISA())
#else	
	typedef ModCloseProcPtr ModCloseUPP;
	
	#define CallModCloseProc(userRoutine, modPBPtr)		\
			(*userRoutine)(modPBPtr)

	#define NewModCloseProc(userRoutine)		\
			(ModOpenUPP)(userRoutine)
#endif


												// PROC DESCRIPTOR - ABOUT
#if USESROUTINEDESCRIPTORS
	typedef UniversalProcPtr ModAboutUPP;

	#define CallModAboutProc(userRoutine, modPBPtr)		\
			CallUniversalProc((UniversalProcPtr)userRoutine, uppModAboutProcInfo, modPBPtr)
			
	#define NewModAboutProc(userRoutine)		\
			(ModAboutUPP) NewRoutineDescriptor((ProcPtr)userRoutine, uppModAboutProcInfo, GetCurrentISA())
#else	
	typedef ModAboutProcPtr ModAboutUPP;
	
	#define CallModAboutProc(userRoutine, modPBPtr)		\
			(*userRoutine)(modPBPtr)

	#define NewModAboutProc(userRoutine)		\
			(ModAboutUPP)(userRoutine)
#endif


												// PROC DESCRIPTOR - CHANGEPREFS
#if USESROUTINEDESCRIPTORS
	typedef UniversalProcPtr ModChangePrefsUPP;

	#define CallModChangePrefsProc(userRoutine, modPBPtr)		\
			CallUniversalProc((UniversalProcPtr)userRoutine, uppModChangePrefsProcInfo, modPBPtr)
			
	#define NewModChangePrefsProc(userRoutine)		\
			(ModChangePrefsUPP) NewRoutineDescriptor((ProcPtr)userRoutine, uppModChangePrefsProcInfo, GetCurrentISA())
#else	
	typedef ModChangePrefsProcPtr ModChangePrefsUPP;
	
	#define CallModChangePrefsProc(userRoutine, modPBPtr)		\
			(*userRoutine)(modPBPtr)

	#define NewModChangePrefsProc(userRoutine)		\
			(ModChangePrefsUPP)(userRoutine)
#endif

