#ifndef __QUICKDRAW__
#include <Quickdraw.h>
#endif

#if defined(powerc) || defined (__powerc)
	#define kNumJuliaPts 1200
#else
	#define kNumJuliaPts 200
#endif

typedef struct
{
	long			numJuliaPts;

	// used to divide random numbers to get small fractional double_ts
	double_t		randDivider;		 
	
	// the # of pixels per unit of Julia space
	double_t		xPixPerUnit;
	double_t		yPixPerUnit;
	
	// globals for walking about on the M set
	double_t 		deltaX;
	double_t		deltaY;
	double_t		boundsLeft;
	double_t		boundsRight;
	double_t		boundsTop;
	double_t		boundsBot;
	double_t		currentX;
	double_t		currentY;
	
	// Colors and color increments for drawing and ramping
	RGBColor	drawColor;
	long		curHue;
	Boolean		useColor;
	//short		rInc, gInc, bInc;
	
	// half of the window dimensions
	long		halfXDim;
	long		halfYDim;			

	long		ptIndex;
	Point		juliaPts[ kNumJuliaPts];
	
	long		pad[40];	// HACK: sizeof() is having a problem 05jul94 bh
	
} JulesData, *JulesDataPtr;
	
// Prototypes
void SmoothWalk(WindowPtr wind);
void InitJules(JulesDataPtr julePtr, Rect *monR);
void JuliaStep(JulesDataPtr julePtr, short numPts, Boolean drawIt);
void GetNextPoint(JulesDataPtr julePtr);
